#****************************************************************************
#**
#**  File     :  /data/lua/EffectTemplates.lua
#**  Author(s):  Gordon Duclos, Greg Kohne, Matt Vainio, Aaron Lundquist
#**
#**  Summary  :  Generic templates for commonly used effects
#**
#**  Copyright  2006 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************
TableCat = import('/lua/utilities.lua').TableCat
EmtBpPath = '/effects/emitters/'
EmtBpPathAlt = '/mods/BlackOpsAR/effects/emitters/'
EmitterTempEmtBpPath = '/effects/emitters/temp/'

#---------------------------------------------------------------
# ### CYBRAN PROJECTILES ###

UnitHitShrapnel01 = { EmtBpPath .. 'destruction_unit_hit_shrapnel_01_emit.bp',}

#------------------------------------------------------------------------
#  Lambda Effects
#------------------------------------------------------------------------
EXLambdaRedirector = {
    EmtBpPathAlt .. 'lambda_distortion_01.bp',
    EmtBpPathAlt .. 'lambda_redirect_bright_01.bp',
    EmtBpPathAlt .. 'lambda_redirect_bright_01.bp',
    EmtBpPathAlt .. 'lambda_redirect_bright_02.bp',
    EmtBpPathAlt .. 'lambda_redirect_bright_02.bp',
    EmtBpPathAlt .. 'lambda_redirect_bright_03.bp',
    EmtBpPathAlt .. 'lambda_distortion_01.bp',
}

EXLambdaDestoyer = {
    EmtBpPathAlt .. 'lambda_distortion_01.bp',
    EmtBpPathAlt .. 'lambda_destroy_dark_01.bp',
    EmtBpPathAlt .. 'lambda_destroy_dark_02.bp',
    #EmtBpPathAlt .. 'lambda_destroy_dark_03a.bp',
    EmtBpPathAlt .. 'lambda_destroy_dark_03b.bp',
    EmtBpPathAlt .. 'lambda_destroy_dark_04.bp',
    EmtBpPathAlt .. 'lambda_destroy_bright_01.bp',
    EmtBpPathAlt .. 'lambda_destroy_bright_01.bp',
    EmtBpPathAlt .. 'lambda_distortion_01.bp',
}


TAntiMatterShellHit05 = {
	EmtBpPath .. 'antimatter_hit_12_emit.bp',	
	EmtBpPath .. 'antimatter_hit_13_emit.bp',	     
	EmtBpPath .. 'antimatter_hit_14_emit.bp',   
	EmtBpPath .. 'antimatter_hit_15_emit.bp',  
	EmtBpPath .. 'antimatter_hit_16_emit.bp',
	EmtBpPath .. 'antimatter_ring_03_emit.bp',	
	EmtBpPath .. 'antimatter_ring_04_emit.bp',	     
	EmtBpPath .. 'quark_bomb_explosion_06_emit.bp',	    
}

#-----------------------------
#   UEF Cruise Missile 01
#-----------------------------
UEFCruiseMissile01Trails = {
    EmtBpPath .. 'missile_sam_munition_trail_01_emit.bp',
    #EmtBpPath .. 'missile_sam_munition_trail_01_emit.bp',
    #EmtBpPath .. 'nuke_munition_launch_trail_04_emit.bp',
    #EmtBpPath .. 'nuke_munition_launch_trail_06_emit.bp',
    #EmtBpPath .. 'missile_munition_trail_01_emit.bp',
    EmtBpPath .. 'missile_munition_trail_02_emit.bp',
    #EmtBpPath .. 'missile_smoke_exhaust_02_emit.bp',
}
